#!/usr/bin/awk -f

#author=olivier dot filangi at rennes.inra.fr
#Calculating Correlation Bravais Pearson Coefficient between two files  

BEGIN {
	File1=ARGV[1]
	File2=ARGV[2]
	n1=0;
	n2=0
	print "Correlation between "File1" and "File2
} 

FILENAME == File1 { 
	n1++;t1[$1]=$2 
} 

FILENAME == File2 { 
	n2++;t2[$1]=$2 
} 

END {
	print "number of progeny in tbv.txt="n1;
	print "number of progeny in tbv.txt="n2;
       
	if ( n1 != n2 ) {
 	       print "Can not calculate correlation."
               exit
	}
     
	 /* mean */
	m1=0;m2=0;
	for (id in t1) {
         if (! id in t2 ) {
	   print id" is not defined in file "File2
	   exit 
	 }
        m1=m1+t1[id];
	m2=m2+t2[id];
	}
	m1=m1/n1;
	m2=m2/n2;
	print "mean1="m1" mean2="m2;

	covxy=0;varx=0;vary=0;

	for (id in t1) {
	  covxy=covxy+(t1[id]-m1)*(t2[id]-m2);
	  varx=varx+(t1[id]-m1)*(t1[id]-m1);
	  vary=vary+(t2[id]-m2)*(t2[id]-m2);
	}
	varx=sqrt(varx)
	vary=sqrt(vary)
	cor=covxy/(varx*vary)
	print "Correlation Bravais-Pearson="cor
}

