/*
 *   This file is part of pls4snp.
 *
 *   pls4snp is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   pls4snp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with pls4snp; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *   Copyright 2013 Olivier Filangi
 *
 */
/*
 * cli.h
 *
 *  Created on: 5 mars 2013
 *      Author: ofilangi
 */

#ifndef CLI_H_
#define CLI_H_

#include <map>
#include <vector>
#include <string>
using namespace std;

#include "convert.hpp"

class cli {
private:
	map<string,string> options;
	string nameProg;
	vector<string> keysValue;

	void set_options_need_values();

public:
	cli(int argc, char* argv[]);
	virtual ~cli();

	template <typename T>
	T getValue(const string & key) {
		map<string,string>::const_iterator it = options.find(key);
		if ( it != options.end() ) {
			T v = Convert::string_to_T<T>((*it).second);
			cout << "["<< key.substr(2,key.size()) << "]="<< v << endl ;
			return v;
		}
		return T();
	}

	static void print_help(char* progname) ;

	bool keyExist (const string & key) const ;

	void check_with_error(const string option,const string & mesg) const ;
};

#endif /* CLI_H_ */
