/*
 *   This file is part of pls4snp.
 *
 *   pls4snp is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   pls4snp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with pls4snp; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *   Copyright 2013 Olivier Filangi
 *
 */
/*
 * convert.hpp
 *
 *  Created on: 1 mars 2013
 *      Author: ofilangi
 */

#ifndef CONVERT_HPP_
#define CONVERT_HPP_

#include "common.hpp"

#include <sstream>
#include <string>
#include <typeinfo>

class Convert
{
public:
        // Convert T, which should be a primitive, to a std::string.
	template <typename T>
	static std::string T_to_string(T const &val)
	{
		std::ostringstream ostr;
		ostr << val;

		return ostr.str();
	}

        // Convert a std::string to T.
	template <typename T>
	static T string_to_T(std::string const &val)
	{
		std::istringstream istr(val);
		T returnVal;
		if (!(istr >> returnVal))
			exitWithError("Convert: Not a valid " + string(typeid(T).name()) + " received!\n");

		return returnVal;
	}

};


#endif /* CONVERT_HPP_ */
