/*
 *   This file is part of pls4snp.
 *
 *   pls4snp is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   pls4snp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with pls4snp; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *   Copyright 2013 Olivier Filangi
 *
 */
#ifndef DATAGEN_HPP_INCLUDED
#define DATAGEN_HPP_INCLUDED
#include <map>
#include <string>

using namespace std;

class dataGen
{
public :
    int n             ; // nanimals
    int nphenoRecord  ; // nanimals in the phenotype file
    int ngenoRecord   ; // nanimals in the genotype file
    int p  ; // nmarkers
    DT **Z; //marker 0,1,2

    // key : phenotype name-> list of performances
    map<string,DT *> mapY;   // List of performance , key is the name of trait
    map<string,DT *> mapEDC; // Effective Daughter Contribution
    /* phenoId/genoId is the id <=> (ID RECORD) */
    map<string,int> phenoId;
    map<string,int> genoId;

    dataGen();
    virtual ~dataGen();
    virtual void release() ;
    virtual void clone(dataGen &,bool genotype=false) const;
};

#endif // DATAGEN_HPP_INCLUDED
