/*
 *   This file is part of pls4snp.
 *
 *   pls4snp is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   pls4snp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with pls4snp; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *   Copyright 2013 Olivier Filangi
 *
 */
#ifndef PLS_HPP_INCLUDED
#define PLS_HPP_INCLUDED

#include "dataGen.hpp"

class workPls
{
public:
    int n  ;   // nanimals
    int p  ;   // nmarkers
    int ncomp; // nombre de composante
    DT ** t ;  // dim n,ncomp
    DT ** u ;  // dim n,ncomp
    DT ** a ;  // dim p,ncomp
    DT * b  ;  // dim ncomp
    DT ** c ;  // dim p,ncomp

    //keep mean and sigma
    DT *meanZ;
    DT *sigmaZ;
    DT meanY;
    DT sigmaY;

    DT *Y;

    //constructeur
    workPls();
    //destructeur
    virtual ~workPls();

    void release();

    void spls2(dataGen & data, string var,int ncomp, int maxiter, DT tol,int keepX=-1);

    void calcul_vip(DT ** VIP,int H);

    void read(ifstream *in,int &nrem,int **listrem) ;

    void write(ofstream *out,int nrem,int *listrem) const ;

private:
    // R : drop(crossprod(u))
   // void step_calcul_crossu(DT & crossu, const DT * u) const ;

    // dim a : nbmarker, Z : nindiv,nbmark, u:nbindiv
    // R : a = t(X.temp) %*% u / drop(crossprod(u))
    // R : c = t(X.temp) %*% t / drop(crossprod(t))
    //
    void step_calcul_tx_y_divcross(DT *a, DT ** Z,const DT * u,const DT & crossu) const ;

    DT update_a_crossa(DT *a) ;

    void step_soft_thres_penalty(DT *a,DT * bufA,int nx);

    // R : t = X.temp %*% a / drop(crossprod(a))
    void step_calcul_t(DT *t, DT ** Z,const DT * a,const DT & crossa) const ;
    // R: b = t(Y.temp) %*% t / drop(crossprod(t))
    void step_calcul_b(DT &b,DT &crosst,DT * Y, DT *t) const;

    void step_calcul_u(DT *u, DT *Y,DT b) const;

    DT  step_calcul_curtol(DT *a_old,DT *a) const ;

    void step_update_z(DT ** Z,DT *t,DT * c,DT *columnIsNa) const ;

    DT step_calcul_d(DT * Y,DT *t,DT crosst) const ;

    void step_update_y(DT * Y,DT *t,DT  d) const ;

} ;

#endif // PLS_HPP_INCLUDED
