/*
 *   This file is part of pls4snp.
 *
 *   pls4snp is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   pls4snp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with pls4snp; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *   Copyright 2013 Olivier Filangi
 *
 */
/*
 * predict.hpp
 *
 *  Created on: 1 mars 2013
 *      Author: ofilangi
 */

#ifndef PREDICT_HPP_
#define PREDICT_HPP_

#include "pls.hpp"

class solPls
{
public:
    int n  ; // nanimals
    int p  ; // nmarkers
    int nsol   ; // number of explicative variates
    DT ** yhat  ; // dim n,ncomp
    DT ** tpred ; // dim n,ncomp
    DT ** bhat  ; // dim p,ncomp
     //constructeur
    solPls();
    //destructeur
    virtual ~solPls();

    void predict(workPls & work,DT ** X_pred, int n_pred,int pAll,int * listOk, int hPredict=-1);

    void write_sol(const dataGen & data,string prefix="",int hselect=-1) const;
};

#endif /* PREDICT_HPP_ */
